.TH "omsb" 3 "Fri Jan 7 2022" "ombs-OnlineMovieBookingSystem" \" -*- nroff -*-
.ad l
.nh
.SH NAME
omsb
.SH SYNOPSIS
.br
.PP
.SS "Classes"

.in +1c
.ti -1c
.RI "class \fBHttpServer\fP"
.br
.RI "this the class that handels user REST API requests\&. we only need to create one object abd start server\&. there is no need to create multiple instanaces in one node as each request is handlled in dedicated thread\&. "
.ti -1c
.RI "class \fBMongoDbHandler\fP"
.br
.RI "this is the class to allow creation of controller objects as needed for ombs mongodb database "
.in -1c
.SS "Variables"

.in +1c
.ti -1c
.RI "constexpr char \fBombsIpAddress\fP [] = '0\&.0\&.0\&.0'"
.br
.ti -1c
.RI "constexpr char \fBombsPort\fP [] = '5000'"
.br
.ti -1c
.RI "constexpr int \fBombsThreads\fP = 100"
.br
.ti -1c
.RI "constexpr char \fBombsAddTheaterEndpoint\fP [] = '/addtheater'"
.br
.ti -1c
.RI "constexpr char \fBombsAddMovieEndpoint\fP [] = '/addmovie'"
.br
.ti -1c
.RI "constexpr char \fBombsGetAllTheatersEndpoint\fP [] = '/getalltheaters'"
.br
.ti -1c
.RI "constexpr char \fBombsGetAllMoviesEndpoint\fP [] = '/getallmovies'"
.br
.ti -1c
.RI "constexpr char \fBombsAddMovieShowEndpoint\fP [] = '/addshow'"
.br
.ti -1c
.RI "constexpr char \fBombsBookSeatsEndpoint\fP [] = '/bookseats'"
.br
.ti -1c
.RI "constexpr char \fBombsGetAllMovieShowsEndpoint\fP [] = '/'"
.br
.ti -1c
.RI "constexpr char \fBombsGetTheaterByMovieEndpoint\fP [] = '/{movie_id}'"
.br
.ti -1c
.RI "constexpr char \fBombsGetAvailableSeatsByMovieAndByTheaterEndpoint\fP [] = '/{movie_id}/{theater_id}'"
.br
.ti -1c
.RI "constexpr char \fBombsMongoDbUri\fP [] = 'mongodb://0\&.0\&.0\&.0'"
.br
.ti -1c
.RI "constexpr char \fBombsOmbsDatabaseName\fP [] = 'ombs_database'"
.br
.ti -1c
.RI "constexpr char \fBombsMovieShowsCollectionName\fP [] = 'movieshows'"
.br
.ti -1c
.RI "constexpr char \fBombsTheatersCollectionName\fP [] = 'theaters'"
.br
.ti -1c
.RI "constexpr char \fBombsMoviesCollectionName\fP [] = 'movies'"
.br
.ti -1c
.RI "constexpr char \fBombsSeatsCollectionName\fP [] = 'seats'"
.br
.ti -1c
.RI "constexpr char \fBombsBookingsCollectionName\fP [] = 'bookings'"
.br
.ti -1c
.RI "const int \fBNUMBER_OF_SEATS_FOR_A_MOVIE_IN_THEATER\fP = 20"
.br
.RI "Assume that available seats number for a couple of given thrater and movie is 20\&. "
.ti -1c
.RI "mongocxx::instance \fBinstance\fP"
.br
.RI "instance to mongodb driver, should be declared only once in all the application\&. "
.ti -1c
.RI "std::mutex \fBseats_booking_mutex_lock\fP"
.br
.RI "this a lock mutex to avoid averbooking when we book a list of seats "
.in -1c
.SH "Variable Documentation"
.PP 
.SS "mongocxx::instance omsb::instance\fC [inline]\fP"

.PP
instance to mongodb driver, should be declared only once in all the application\&. 
.SS "const int omsb::NUMBER_OF_SEATS_FOR_A_MOVIE_IN_THEATER = 20"

.PP
Assume that available seats number for a couple of given thrater and movie is 20\&. 
.SS "constexpr char omsb::ombsAddMovieEndpoint[] = '/addmovie'\fC [constexpr]\fP"

.SS "constexpr char omsb::ombsAddMovieShowEndpoint[] = '/addshow'\fC [constexpr]\fP"

.SS "constexpr char omsb::ombsAddTheaterEndpoint[] = '/addtheater'\fC [constexpr]\fP"

.SS "constexpr char omsb::ombsBookingsCollectionName[] = 'bookings'\fC [constexpr]\fP"

.SS "constexpr char omsb::ombsBookSeatsEndpoint[] = '/bookseats'\fC [constexpr]\fP"

.SS "constexpr char omsb::ombsGetAllMoviesEndpoint[] = '/getallmovies'\fC [constexpr]\fP"

.SS "constexpr char omsb::ombsGetAllMovieShowsEndpoint[] = '/'\fC [constexpr]\fP"

.SS "constexpr char omsb::ombsGetAllTheatersEndpoint[] = '/getalltheaters'\fC [constexpr]\fP"

.SS "constexpr char omsb::ombsGetAvailableSeatsByMovieAndByTheaterEndpoint[] = '/{movie_id}/{theater_id}'\fC [constexpr]\fP"

.SS "constexpr char omsb::ombsGetTheaterByMovieEndpoint[] = '/{movie_id}'\fC [constexpr]\fP"

.SS "constexpr char omsb::ombsIpAddress[] = '0\&.0\&.0\&.0'\fC [constexpr]\fP"

.SS "constexpr char omsb::ombsMongoDbUri[] = 'mongodb://0\&.0\&.0\&.0'\fC [constexpr]\fP"

.SS "constexpr char omsb::ombsMoviesCollectionName[] = 'movies'\fC [constexpr]\fP"

.SS "constexpr char omsb::ombsMovieShowsCollectionName[] = 'movieshows'\fC [constexpr]\fP"

.SS "constexpr char omsb::ombsOmbsDatabaseName[] = 'ombs_database'\fC [constexpr]\fP"

.SS "constexpr char omsb::ombsPort[] = '5000'\fC [constexpr]\fP"

.SS "constexpr char omsb::ombsSeatsCollectionName[] = 'seats'\fC [constexpr]\fP"

.SS "constexpr char omsb::ombsTheatersCollectionName[] = 'theaters'\fC [constexpr]\fP"

.SS "constexpr int omsb::ombsThreads = 100\fC [constexpr]\fP"

.SS "std::mutex omsb::seats_booking_mutex_lock\fC [inline]\fP"

.PP
this a lock mutex to avoid averbooking when we book a list of seats 
.SH "Author"
.PP 
Generated automatically by Doxygen for ombs-OnlineMovieBookingSystem from the source code\&.
